#
# This file was generated using xslt from its XML file
#
# Copyright 2009, Associated Universities Inc., Washington DC
#
import sys
import os
from  casac import *
import string
from taskinit import casalog
from taskinit import xmlpath
#from taskmanager import tm
import task_fringefit
def fringefit(vis='', caltable='', field='', spw='', intent='', selectdata=True, timerange='', antenna='', scan='', observation='', msselect='', solint='inf', combine='', refant='', minsnr=3.0, zerorates=False, globalsolve=True, niter=100, delaywindow=[], ratewindow=[], append=False, corrdepflags=False, docallib=False, callib='', gaintable=[''], gainfield=[''], interp=[''], spwmap=[], paramactive=[], parang=False):

        """Fringe fit delay and rates
  For more information, see the task pages of gaincal in CASA Docs:

  https://casa.nrao.edu/casadocs/
      minsnr -- Reject solutions below this SNR
              default: 3.0 

        """
        if type(delaywindow)==float: delaywindow=[delaywindow]
        if type(ratewindow)==float: ratewindow=[ratewindow]
        if type(gaintable)==str: gaintable=[gaintable]
        if type(gainfield)==str: gainfield=[gainfield]
        if type(interp)==str: interp=[interp]
        if type(spwmap)==int: spwmap=[spwmap]
        if type(paramactive)==bool: paramactive=[paramactive]

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['caltable'] = caltable
        mytmp['field'] = field
        mytmp['spw'] = spw
        mytmp['intent'] = intent
        mytmp['selectdata'] = selectdata
        mytmp['timerange'] = timerange
        mytmp['antenna'] = antenna
        mytmp['scan'] = scan
        mytmp['observation'] = observation
        mytmp['msselect'] = msselect
        mytmp['solint'] = solint
        mytmp['combine'] = combine
        mytmp['refant'] = refant
        mytmp['minsnr'] = minsnr
        mytmp['zerorates'] = zerorates
        mytmp['globalsolve'] = globalsolve
        mytmp['niter'] = niter
        mytmp['delaywindow'] = delaywindow
        mytmp['ratewindow'] = ratewindow
        mytmp['append'] = append
        mytmp['corrdepflags'] = corrdepflags
        mytmp['docallib'] = docallib
        mytmp['callib'] = callib
        mytmp['gaintable'] = gaintable
        mytmp['gainfield'] = gainfield
        mytmp['interp'] = interp
        mytmp['spwmap'] = spwmap
        mytmp['paramactive'] = paramactive
        mytmp['parang'] = parang
        pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.utils().torecord(pathname+'fringefit.xml')

        casalog.origin('fringefit')
        if trec.has_key('fringefit') and casac.utils().verify(mytmp, trec['fringefit']) :
            result = task_fringefit.fringefit(vis, caltable, field, spw, intent, selectdata, timerange, antenna, scan, observation, msselect, solint, combine, refant, minsnr, zerorates, globalsolve, niter, delaywindow, ratewindow, append, corrdepflags, docallib, callib, gaintable, gainfield, interp, spwmap, paramactive, parang)

        else :
          result = False
        return result
