#
# This file was generated using xslt from its XML file
#
# Copyright 2014, Associated Universities Inc., Washington DC
#
import sys
import os
import datetime
#from casac import *
import casac
import string
import time
import inspect
import numpy
from casa_stack_manip import stack_frame_find
from odict import odict
from types import *
from task_fringefit import fringefit
class fringefit_cli_:
    __name__ = "fringefit"
    rkey = None
    i_am_a_casapy_task = None
    # The existence of the i_am_a_casapy_task attribute allows help()
    # (and other) to treat casapy tasks as a special case.

    def __init__(self) :
       self.__bases__ = (fringefit_cli_,)
       self.__doc__ = self.__call__.__doc__

       self.parameters={'vis':None, 'caltable':None, 'field':None, 'spw':None, 'intent':None, 'selectdata':None, 'timerange':None, 'antenna':None, 'scan':None, 'observation':None, 'msselect':None, 'solint':None, 'combine':None, 'refant':None, 'minsnr':None, 'zerorates':None, 'globalsolve':None, 'niter':None, 'delaywindow':None, 'ratewindow':None, 'append':None, 'corrdepflags':None, 'docallib':None, 'callib':None, 'gaintable':None, 'gainfield':None, 'interp':None, 'spwmap':None, 'paramactive':None, 'parang':None, }


    def result(self, key=None):
            #### and add any that have completed...
            return None


    def __call__(self, vis=None, caltable=None, field=None, spw=None, intent=None, selectdata=None, timerange=None, antenna=None, scan=None, observation=None, msselect=None, solint=None, combine=None, refant=None, minsnr=None, zerorates=None, globalsolve=None, niter=None, delaywindow=None, ratewindow=None, append=None, corrdepflags=None, docallib=None, callib=None, gaintable=None, gainfield=None, interp=None, spwmap=None, paramactive=None, parang=None, ):

        """Fringe fit delay and rates

        Detailed Description:

Phase offsets, groups delays and delay rates are calculated with
respect to a specified referance antenna by a two-dimensional FFT and
subsequent least-squares optimisation.

Previous calibrations should be applied on the fly.


        Arguments :
                vis: Name of input visibility file
                   Default Value: 

                caltable: Name of output gain calibration table
                   Default Value: 

                field: Select field using field id(s) or field name(s)
                   Default Value: 

                spw: Select spectral window/channels
                   Default Value: 

                intent: Select observing intent
                   Default Value: 

                selectdata: Other data selection parameters
                   Default Value: True

                timerange: Select data based on time range
                   Default Value: 

                antenna: Select data based on antenna/baseline
                   Default Value: 

                scan: Scan number range
                   Default Value: 

                observation: Select by observation ID(s)
                   Default Value: 

                msselect: Optional complex data selection (ignore for now)
                   Default Value: 

                solint: Solution interval: egs. \'inf\', \'60s\' (see help)
                   Default Value: inf

                combine: Data axes which to combine for solve (obs, scan, spw, and/or field)
                   Default Value: 

                refant: Reference antenna name(s)
                   Default Value: 

                minsnr: Reject solutions below this signal-to-noise ratio (at the FFT stage)
                   Default Value: 3.0

                zerorates: Zero delay-rates in solution table

        Write a solution table with delay-rates zeroed, for the case of
    "manual phase calibration", so that the calibration table can be
    applied to the full dataset without the extrapolation of a non-zero delay-rate term
    affecting the data
    
                   Default Value: False

                globalsolve: Refine estimates of delay and rate with global least-squares solver
                   Default Value: True

                niter: Maximum number of iterations for least-squares solver
                   Default Value: 100

                delaywindow: Constrain FFT delay search to a window specified as a two-element list with units of nanoseconds
    Default: [None, None]
    Examples: [-10, 10]
    
                   Default Value: 

                ratewindow: Constrain FFT rate search to a window specified as a two-element list with units of seconds per second
      Default: [None, None]
      Examples: [-1e-13, 1e-13]
    
                   Default Value: 

                append: Append solutions to the (existing) table
    Default: False (overwrite existing table or make
    new table)

    Appended solutions must be derived from the same
    MS as the existing caltable, and solution spws
    must have the same meta-info (according to spw
    selection and solint) or be non-overlapping.
    
                   Default Value: False

                corrdepflags:  If False (default), if any correlation is flagged, treat all correlations in
        the visibility vector as flagged when solving (per channel, per baseline).
        If True, use unflagged correlations in a visibility vector, even if one or more
        other correlations are flagged.
              
        Default: False (treat correlation vectors with one or more correlations flagged as entirely flagged)
  
        Traditionally, CASA has observed a strict interpretation of 
        correlation-dependent flags: if one or more correlations 
        (for any baseline and channel) is flagged, then all available 
        correlations for the same baseline and channel are 
        treated as flagged.  However, it is desirable in some 
        circumstances to relax this stricture, e.g., to preserve use
        of data from antennas with only one good polarization (e.g., one polarization
        is bad or entirely absent).  Solutions for the bad or missing polarization 
        will be rendered as flagged.

      
                   Default Value: False

                docallib: Control means of specifying the caltables
                     Default: False (Use gaintable, gainfield, interp,
                     spwmap, calwt)
                     Options: False|True

                     If True, specify a file containing cal library in
                     callib
    
                   Default Value: False

                callib: Specify a file containing cal library directives
    Subparameter of docallib=True
    
                   Default Value: 

                gaintable: Gain calibration table(s) to apply on the fly
    Default: '' (none)
    Subparameter of docallib=False
    Examples: 
    gaintable='ngc5921.gcal'
    gaintable=['ngc5921.ampcal','ngc5921.phcal']
    
                   Default Value: 

                gainfield: Select a subset of calibrators from gaintable(s)
    Default: '' (all sources on the sky)

    'nearest' ==> nearest (on sky) available field in
    table otherwise, same syntax as field

    Examples: 
    gainfield='0~2,5' means use fields 0,1,2,5
    from gaintable
    gainfield=['0~3','4~6'] means use field 0
    through 3
    
                   Default Value: 

                interp: Interpolation parameters (in time[,freq]) for each gaintable, as a list of strings.
    Default: '' --> 'linear,linear' for all gaintable(s)
    Options: Time: 'nearest', 'linear'
    Freq: 'nearest', 'linear', 'cubic',
    'spline'
    Specify a list of strings, aligned with the list of caltable specified
    in gaintable, that contain the required interpolation parameters
    for each caltable.
    * When frequency interpolation is relevant (B, Df,
    Xf), separate time-dependent and freq-dependent
    interp types with a comma (freq_after_ the
    comma). 
    * Specifications for frequency are ignored when the
    calibration table has no channel-dependence. 
    * Time-dependent interp options ending in 'PD'
    enable a "phase delay" correction per spw for
    non-channel-dependent calibration types.
    * For multi-obsId datasets, 'perobs' can be
    appended to the time-dependent interpolation
    specification to enforce obsId boundaries when
    interpolating in time. 
    * Freq-dependent interp options can have 'flag' appended
    to enforce channel-dependent flagging, and/or 'rel' 
    appended to invoke relative frequency interpolation

    Examples: 
    interp='nearest' (in time, freq-dep will be
    linear, if relevant)
    interp='linear,cubic'  (linear in time, cubic
    in freq)
    interp='linearperobs,splineflag' (linear in
    time per obsId, spline in freq with
    channelized flagging)
    interp='nearest,linearflagrel' (nearest in
    time, linear in freq with with channelized 
    flagging and relative-frequency interpolation)
    interp=',spline'  (spline in freq; linear in
    time by default)
    interp=['nearest,spline','linear']  (for
    multiple gaintables)
    
                   Default Value: 

                spwmap: Spectral window mappings to form for gaintable(s)
                     Only used if callib=False
                     default: [] (apply solutions from each calibration spw to
                     the same MS spw only)
                     Any available calibration spw can be mechanically mapped to any 
                      MS spw. 
                     Examples:
                        spwmap=[0,0,1,1] means apply calibration 
                          from cal spw = 0 to MS spw 0,1 and cal spw 1 to MS spws 2,3.
                        spwmap=[[0,0,1,1],[0,1,0,1]] (use a list of lists for multiple
                          gaintables)
	  
                   Default Value: 

                paramactive: Control which parameters are solved for; a vector of (exactly) three booleans for delay, delay-rate and dispersive delay (in that order)
                   Default Value: 

                parang: Apply parallactic angle correction on the fly.
            
                   Default Value: False


        Example :

  For more information, see the task pages of gaincal in CASA Docs:

  https://casa.nrao.edu/casadocs/
      minsnr -- Reject solutions below this SNR
              default: 3.0 

        """
        if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=stack_frame_find( )
        #casac = self.__globals__['casac']
        casalog = self.__globals__['casalog']
        casa = self.__globals__['casa']
        #casalog = casac.casac.logsink()
        self.__globals__['__last_task'] = 'fringefit'
        self.__globals__['taskname'] = 'fringefit'
        ###
        self.__globals__['update_params'](func=self.__globals__['taskname'],printtext=False,ipython_globals=self.__globals__)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
        if type(self.__call__.func_defaults) is NoneType:
            function_signature_defaults={}
        else:
            function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames[1:],self.__call__.func_defaults))
        useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
                        if (key != 'self') :
                           useLocalDefaults = True

        myparams = {}
        if useLocalDefaults :
           for item in function_signature_defaults.iteritems():
               key,val = item
               keyVal = eval(key)
               exec('myparams[key] = keyVal')
               self.parameters[key] = keyVal
               if (keyVal == None):
                   exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
                   keyVal = eval(key)
                   if(type(keyVal) == dict) :
                      if len(keyVal) > 0 :
                         exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')
                      else :
                         exec('myparams[key] = ' + key + ' = {}')

        else :
            print ''

            myparams['vis'] = vis = self.parameters['vis']
            myparams['caltable'] = caltable = self.parameters['caltable']
            myparams['field'] = field = self.parameters['field']
            myparams['spw'] = spw = self.parameters['spw']
            myparams['intent'] = intent = self.parameters['intent']
            myparams['selectdata'] = selectdata = self.parameters['selectdata']
            myparams['timerange'] = timerange = self.parameters['timerange']
            myparams['antenna'] = antenna = self.parameters['antenna']
            myparams['scan'] = scan = self.parameters['scan']
            myparams['observation'] = observation = self.parameters['observation']
            myparams['msselect'] = msselect = self.parameters['msselect']
            myparams['solint'] = solint = self.parameters['solint']
            myparams['combine'] = combine = self.parameters['combine']
            myparams['refant'] = refant = self.parameters['refant']
            myparams['minsnr'] = minsnr = self.parameters['minsnr']
            myparams['zerorates'] = zerorates = self.parameters['zerorates']
            myparams['globalsolve'] = globalsolve = self.parameters['globalsolve']
            myparams['niter'] = niter = self.parameters['niter']
            myparams['delaywindow'] = delaywindow = self.parameters['delaywindow']
            myparams['ratewindow'] = ratewindow = self.parameters['ratewindow']
            myparams['append'] = append = self.parameters['append']
            myparams['corrdepflags'] = corrdepflags = self.parameters['corrdepflags']
            myparams['docallib'] = docallib = self.parameters['docallib']
            myparams['callib'] = callib = self.parameters['callib']
            myparams['gaintable'] = gaintable = self.parameters['gaintable']
            myparams['gainfield'] = gainfield = self.parameters['gainfield']
            myparams['interp'] = interp = self.parameters['interp']
            myparams['spwmap'] = spwmap = self.parameters['spwmap']
            myparams['paramactive'] = paramactive = self.parameters['paramactive']
            myparams['parang'] = parang = self.parameters['parang']

        if type(delaywindow)==float: delaywindow=[delaywindow]
        if type(ratewindow)==float: ratewindow=[ratewindow]
        if type(gaintable)==str: gaintable=[gaintable]
        if type(gainfield)==str: gainfield=[gainfield]
        if type(interp)==str: interp=[interp]
        if type(spwmap)==int: spwmap=[spwmap]
        if type(paramactive)==bool: paramactive=[paramactive]

        result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['caltable'] = caltable
        mytmp['field'] = field
        mytmp['spw'] = spw
        mytmp['intent'] = intent
        mytmp['selectdata'] = selectdata
        mytmp['timerange'] = timerange
        mytmp['antenna'] = antenna
        mytmp['scan'] = scan
        mytmp['observation'] = observation
        mytmp['msselect'] = msselect
        mytmp['solint'] = solint
        mytmp['combine'] = combine
        mytmp['refant'] = refant
        mytmp['minsnr'] = minsnr
        mytmp['zerorates'] = zerorates
        mytmp['globalsolve'] = globalsolve
        mytmp['niter'] = niter
        mytmp['delaywindow'] = delaywindow
        mytmp['ratewindow'] = ratewindow
        mytmp['append'] = append
        mytmp['corrdepflags'] = corrdepflags
        mytmp['docallib'] = docallib
        mytmp['callib'] = callib
        mytmp['gaintable'] = gaintable
        mytmp['gainfield'] = gainfield
        mytmp['interp'] = interp
        mytmp['spwmap'] = spwmap
        mytmp['paramactive'] = paramactive
        mytmp['parang'] = parang
        pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.casac.utils().torecord(pathname+'fringefit.xml')

        casalog.origin('fringefit')
        try :
          #if not trec.has_key('fringefit') or not casac.casac.utils().verify(mytmp, trec['fringefit']) :
            #return False

          casac.casac.utils().verify(mytmp, trec['fringefit'], True)
          scriptstr=['']
          saveinputs = self.__globals__['saveinputs']

          # Save .last file for this task execution. MPI servers don't write it (CASR-329).
          from mpi4casa.MPIEnvironment import MPIEnvironment
          do_full_logging = MPIEnvironment.is_mpi_disabled_or_client()
          if type(self.__call__.func_defaults) is NoneType:
              saveinputs=''
          else:
              saveinputs('fringefit', 'fringefit.last', myparams, self.__globals__,scriptstr=scriptstr, do_save_inputs=do_full_logging)

          tname = 'fringefit'
          spaces = ' '*(18-len(tname))
          casalog.post('\n##########################################'+
                       '\n##### Begin Task: ' + tname + spaces + ' #####')
          # Don't do telemetry from MPI servers (CASR-329)
          if do_full_logging and casa['state']['telemetry-enabled']:
              #casalog.poststat('Begin Task: ' + tname)
              task_starttime = str(datetime.datetime.now())
          if type(self.__call__.func_defaults) is NoneType:
              casalog.post(scriptstr[0]+'\n', 'INFO')
          else:
              casalog.post(scriptstr[1][1:]+'\n', 'INFO')

          # Effective call to the task as defined in gcwrap/python/scripts/task_*
          result = fringefit(vis, caltable, field, spw, intent, selectdata, timerange, antenna, scan, observation, msselect, solint, combine, refant, minsnr, zerorates, globalsolve, niter, delaywindow, ratewindow, append, corrdepflags, docallib, callib, gaintable, gainfield, interp, spwmap, paramactive, parang)

          if do_full_logging and casa['state']['telemetry-enabled']:
              task_endtime = str(datetime.datetime.now())
              casalog.poststat( 'Task ' + tname + ' complete. Start time: ' + task_starttime + ' End time: ' + task_endtime )
          casalog.post('##### End Task: ' + tname + '  ' + spaces + ' #####'+
                       '\n##########################################')

        except Exception, instance:
          from mpi4casa.MPIEnvironment import MPIEnvironment
          if (self.__globals__.has_key('__rethrow_casa_exceptions') and self.__globals__['__rethrow_casa_exceptions']) or\
             (MPIEnvironment.is_mpi_enabled and not MPIEnvironment.is_mpi_client):
             raise
          else:
             #print '**** Error **** ',instance
             tname = 'fringefit'
             casalog.post('Task {} raised an exception of class {} with the following message: {}'.
                          format(tname, type(instance).__name__, instance), 'ERROR')
             pass
        casalog.origin('')

        return result
#
#
#
#    def paramgui(self, useGlobals=True, ipython_globals=None):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#        if not hasattr(self, "__globals__") or self.__globals__ == None :
#           self.__globals__=stack_frame_find( )
#
#        if useGlobals:
#            if ipython_globals == None:
#                myf=self.__globals__
#            else:
#                myf=ipython_globals
#
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('fringefit', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None, ipython_globals=None, paramvalue=None, subparam=None):
        if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=stack_frame_find( )
        if ipython_globals == None:
            myf=self.__globals__
        else:
            myf=ipython_globals

        a = odict()
        a['vis']  = ''
        a['caltable']  = ''
        a['field']  = ''
        a['spw']  = ''
        a['intent']  = ''
        a['selectdata']  = True
        a['solint']  = 'inf'
        a['combine']  = ''
        a['refant']  = ''
        a['minsnr']  = 3.0
        a['zerorates']  = False
        a['globalsolve']  = True
        a['niter']  = 100
        a['delaywindow']  = []
        a['ratewindow']  = []
        a['append']  = False
        a['corrdepflags']  = False
        a['docallib']  = False
        a['paramactive']  = []
        a['parang']  = False

        a['selectdata'] = {
                    0:odict([{'value':True}, {'timerange':''}, {'antenna':''}, {'scan':''}, {'observation':''}, {'msselect':''}]), 
                    1:{'value':False}}
        a['docallib'] = {
                    0:odict([{'value':False}, {'gaintable':[]}, {'gainfield':[]}, {'interp':[]}, {'spwmap':[]}]), 
                    1:odict([{'value':True}, {'callib':''}])}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
            if(paramvalue==None and subparam==None):
               if(a.has_key(param)):
                  return a[param]
               else:
                  return self.itsdefault(param)
            else:
               retval=a[param]
               if(type(a[param])==dict):
                  for k in range(len(a[param])):
                     valornotval='value'
                     if(a[param][k].has_key('notvalue')):
                        valornotval='notvalue'
                     if((a[param][k][valornotval])==paramvalue):
                        retval=a[param][k].copy()
                        retval.pop(valornotval)
                        if(subparam != None):
                           if(retval.has_key(subparam)):
                              retval=retval[subparam]
                           else:
                              retval=self.itsdefault(subparam)
                     else:
                        retval=self.itsdefault(subparam)
               return retval


#
#
    def check_params(self, param=None, value=None, ipython_globals=None):
      if ipython_globals == None:
          myf=self.__globals__
      else:
          myf=ipython_globals
#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value
#
#
    def description(self, key='fringefit', subkey=None):
        desc={'fringefit': 'Fringe fit delay and rates',
               'vis': 'Name of input visibility file',
               'caltable': 'Name of output gain calibration table',
               'field': 'Select field using field id(s) or field name(s)',
               'spw': 'Select spectral window/channels',
               'intent': 'Select observing intent',
               'selectdata': 'Other data selection parameters',
               'timerange': 'Select data based on time range',
               'antenna': 'Select data based on antenna/baseline',
               'scan': 'Scan number range',
               'observation': 'Select by observation ID(s)',
               'msselect': 'Optional complex data selection (ignore for now)',
               'solint': 'Solution interval: egs. \'inf\', \'60s\' (see help)',
               'combine': 'Data axes which to combine for solve (obs, scan, spw, and/or field)',
               'refant': 'Reference antenna name(s)',
               'minsnr': 'Reject solutions below this signal-to-noise ratio (at the FFT stage)',
               'zerorates': 'Zero delay-rates in solution table',
               'globalsolve': 'Refine estimates of delay and rate with global least-squares solver',
               'niter': 'Maximum number of iterations for least-squares solver',
               'delaywindow': 'Constrain FFT delay search to a window',
               'ratewindow': 'Constrain FFT rate search to a window',
               'append': 'Append solutions to the (existing) table',
               'corrdepflags': 'Respect correlation-dependent flags',
               'docallib': 'Use callib or traditional cal apply parameters',
               'callib': 'Cal Library filename',
               'gaintable': 'Gain calibration table(s) to apply on the fly',
               'gainfield': 'Select a subset of calibrators from gaintable(s)',
               'interp': 'Temporal interpolation for each gaintable (''=linear)',
               'spwmap': 'Spectral window mappings to form for gaintable(s)',
               'paramactive': 'Control which parameters are solved for',
               'parang': 'Apply parallactic angle correction on the fly',

              }

#
# Set subfields defaults if needed
#

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['vis']  = ''
        a['caltable']  = ''
        a['field']  = ''
        a['spw']  = ''
        a['intent']  = ''
        a['selectdata']  = True
        a['timerange']  = ''
        a['antenna']  = ''
        a['scan']  = ''
        a['observation']  = ''
        a['msselect']  = ''
        a['solint']  = 'inf'
        a['combine']  = ''
        a['refant']  = ''
        a['minsnr']  = 3.0
        a['zerorates']  = False
        a['globalsolve']  = True
        a['niter']  = 100
        a['delaywindow']  = []
        a['ratewindow']  = []
        a['append']  = False
        a['corrdepflags']  = False
        a['docallib']  = False
        a['callib']  = ''
        a['gaintable']  = ['']
        a['gainfield']  = ['']
        a['interp']  = ['']
        a['spwmap']  = []
        a['paramactive']  = []
        a['parang']  = False

        #a = sys._getframe(len(inspect.stack())-1).f_globals

        if self.parameters['selectdata']  == True:
            a['timerange'] = ''
            a['antenna'] = ''
            a['scan'] = ''
            a['observation'] = ''
            a['msselect'] = ''

        if self.parameters['docallib']  == False:
            a['gaintable'] = []
            a['gainfield'] = []
            a['interp'] = []
            a['spwmap'] = []

        if self.parameters['docallib']  == True:
            a['callib'] = ''

        if a.has_key(paramname) :
              return a[paramname]
fringefit_cli = fringefit_cli_()
