#
# This file was generated using xslt from its XML file
#
# Copyright 2014, Associated Universities Inc., Washington DC
#
import sys
import os
import datetime
#from casac import *
import casac
import string
import time
import inspect
import numpy
from casa_stack_manip import stack_frame_find
from odict import odict
from types import *
from task_sdatmcor import sdatmcor
class sdatmcor_cli_:
    __name__ = "sdatmcor"
    rkey = None
    i_am_a_casapy_task = None
    # The existence of the i_am_a_casapy_task attribute allows help()
    # (and other) to treat casapy tasks as a special case.

    def __init__(self) :
       self.__bases__ = (sdatmcor_cli_,)
       self.__doc__ = self.__call__.__doc__

       self.parameters={'infile':None, 'datacolumn':None, 'outfile':None, 'overwrite':None, 'field':None, 'spw':None, 'scan':None, 'antenna':None, 'correlation':None, 'timerange':None, 'intent':None, 'observation':None, 'feed':None, 'msselect':None, 'outputspw':None, 'gainfactor':None, 'dtem_dh':None, 'h0':None, 'atmtype':None, 'atmdetail':None, 'altitude':None, 'temperature':None, 'pressure':None, 'humidity':None, 'pwv':None, 'dp':None, 'dpm':None, 'layerboundaries':None, 'layertemperature':None, }


    def result(self, key=None):
            #### and add any that have completed...
            return None


    def __call__(self, infile=None, datacolumn=None, outfile=None, overwrite=None, field=None, spw=None, scan=None, antenna=None, correlation=None, timerange=None, intent=None, observation=None, feed=None, msselect=None, outputspw=None, gainfactor=None, dtem_dh=None, h0=None, atmtype=None, atmdetail=None, altitude=None, temperature=None, pressure=None, humidity=None, pwv=None, dp=None, dpm=None, layerboundaries=None, layertemperature=None, ):

        """Offline correction of residual atmospheric features

        Detailed Description:


    The task sdatmcor provides the capability of offline correction of
    residual atmospheric features in the calibrated single-dish spectra
    which result from the difference of elevation angle between ON_SOURCE
    and OFF_SOURCE measurements.

    The correction factor is derived from the atmosphere model based on
    the atmospheric properties (temperature, pressure, etc.) measured
    during the observation. The model is constructed by the atmosphere
    (at) tool.

    For spw selection, two selection parameters, spw and outputspw,
    are available. The former specifies the data to be
    corrected while the latter corresponds to the spw for output.
    In practice, intersection of spw and outputspw is corrected.
    For example, when spw='19,23' and outputspw='19', spw 23 is not
    corrected because data for spw 23 is not written to outfile so
    that the correction is not meaningful.
    For data selection parameters other than spw,  only data selected
    by data selection parameters are corrected and written to the outfile.

    Note that outfile will have the data column DATA regardless of
    what data column exists in infile.


        Arguments :
                infile: name of input MS.
                   Default Value: 

                datacolumn: name of data column to be used ["data", "float_data", or "corrected"]
                   Default Value: data
                   Allowed Values:
                                data
                                float_data
                                corrected

                outfile: name of output MS.
                   Default Value: 

                overwrite: allow to overwrite the output file if already exists.
                   Default Value: False

                field: Select fields. Use field id(s) or name(s).

                       If field string is a non-negative integer, it is assumed to
                       be a field index otherwise, it is assumed to be a field name.

                       Default: ''= all fields

                       Example:
                         field='0~2'; field ids 0,1,2
                         field='0,4,5~7'; field ids 0,4,5,6,7
                         field='3C286,3C295'; field named 3C286 and 3C295
                         field = '3,4C*'; field id 3, all names starting with 4C

        
                   Default Value: 

                spw: Select spectral windows

                       Note that spw specifies the list of spw ids to apply correction.
                       Spw ids to output should be specified by outputspw.

                       Note also that channel selection is not available for this task.

                       Default: ''=all spectral windows
                       Example:
                          spw='0~2,4'; spectral windows 0,1,2,4
                          spw='<2';   spectral windows less than 2 (i.e. 0,1)
                          spw='0,10'; spw 0,10

        
                   Default Value: 

                scan: Scan number range

                      Default: '' (all)
                      Example: scan='1~5'
        
                   Default Value: 

                antenna: Select data based on antenna/baseline

                       If antenna string is a non-negative integer, it is
                       assumed to be an antenna index, otherwise, it is
                       considered an antenna name.

                       If specified selection doesn't contain any autocorrelation,
                       the selection will be tweaked to include autocorrelation data.
                       For example, 'PM02' will be interpreted as 'PM02&&&'.

                       Default: '' (all)
                       Example:
                       antenna='5&6'; baseline between antenna index 5 and
                                     index 6.
                       antenna='VA05&VA06'; baseline between VLA antenna 5
                                           and 6.
                       antenna='5&6;7&8'; baselines 5-6 and 7-8
                       antenna='5'; all baselines with antenna index 5
                       antenna='05'; all baselines with antenna number 05
                                    (VLA old name)
                       antenna='5,6,9'; all baselines with antennas 5,6,9
                                       index number

        
                   Default Value: 

                correlation: Correlation (polarization) types or expression

                       Default: '' (all correlations)
                       Example: correlation='XX,YY'
        
                   Default Value: 

                timerange: Range of time to select from data

                       timerange = 'YYYY/MM/DD/hh:mm:ss~YYYY/MM/DD/hh:mm:ss'
                       Note: if YYYY/MM/DD is missing date defaults to first
                             day in data set

                       Default: '' (all)
                       Example:
                       timerange='09:14:0~09:54:0' picks 40 min on first day
                       timerange='25:00:00~27:30:00' picks 1 hr to 3 hr
                                 30min on NEXT day
                       timerange='09:44:00' pick data within one integration
                                 of time
                       timerange='> 10:24:00' data after this time
        
                   Default Value: 

                intent: Scan Intent(s)

                       Default: '' (all)
                       Example:
                       intent='TARGET_SOURCE'
                       intent='TARGET_SOURCE1,TARGET_SOURCE2'
                       intent='TARGET_POINTING*'
        
                   Default Value: 

                observation: Observation ID range

                       Default: '' (all observations)
                       Example: observation='0~5'
        
                   Default Value: 

                feed: feed selection

                       Default: '' (all feeds)
                       Example: feed='0,1'
        
                   Default Value: 

                msselect: Complicated data selection using TaQL

                       Complicated data selection that cannot be supported by other
                       data selection parameters should be specified here using TaQL.
                       See Casacore Note 199 for detailed syntax of TaQL:

                         https://casacore.github.io/casacore-notes/199.html

                       Default: '' (all data)
                       Example:
                       msselect='ABS(DATA) < 1 && ANTENNA1 == ANTENNA2 + 1'
                       msselect='ROWNUMBER() < 100'
        
                   Default Value: 

                outputspw: select spws to output, same syntax of spw.("" = all)

                       Note that outputspw specifies the list of spw ids to output.
                       Spw ids to be corrected should be specified by spw.

                       Note also that channel selection is not available for this task.

        
                   Default Value: 

                gainfactor: Gain factor to multiply correction term.

                       In ALMA data reduction, intensity of calibrated spectra, antenna
                       temperature Ta* in unit of Kelvin, is converted to Jansky (Jy)
                       by multiplying conversion factor. This parameter is intended to
                       apply exactly the same multiplicative factor to correction term.
                       If no conversion is applied to spectral data, gainfactor should
                       be 1.0, which means that the correction is in unit of Ta*.
                       The value can be float, dict, or string. Default is 1.0.

                       Float value is interpreted as fixed factor, which is applied to all spws.

                       Dict should be the pair of spw id (key) and the factor to be applied (value).
                       Key should be string rather than int.

                       If string is given, it should be the name of caltable. For caltable,
                       inverse square of stored value is applied.

                       Default: 1.0
                       Example: 10.0
                                {'17': 45.0, '19': 43.5, '21': 42.0, '23': 40.0}
                                'k2jycal.tbl'

        
                   Default Value: 1.0

                dtem_dh: temperature gradient [K/km], e.g. -5.6. ("" = Tool default)

                       The value is directly passed to initialization method for ATM model.
                       Float and string types are acceptable. Float value is interpreted as
                       the value in K/km. String value should be the numeric value with unit
                       such as '-5.6K/km'.

                       Default: '' (tool default, -5.6K/km, is used)

        
                   Default Value: 

                h0: scale height for water [km], e.g. 2.0. ("" = Tool default)

                       The value is directly passed to initialization method for ATM model.
                       Float and string types are acceptable. Float value is interpreted as
                       the value in kilometer. String value should be the numeric value with
                       unit compatible with length, such as '2km' or '2000m'.

        
                   Default Value: 

                atmtype: Atmospheric type.
                       The value is directly passed to initialization method for ATM model.
                       The type should be specified as integer. Available options are,

                         1: tropical
                         2: mid latitude summer (default)
                         3: mid latitude winter
                         4: subarctic summer
                         5: subarctic winter

        
                   Default Value: 2

                atmdetail: Expose parameters for detailed configuration of ATM model if True.

                       The following parameters are exposed to the user if atmdetail is True:

                         altitude
                         temperature
                         pressure
                         humidity
                         pwv
                         dp
                         dpm
                         layerboundaries
                         layertemperature

        
                   Default Value: False

                altitude: Site altitude [m].

                       The value is directly passed to initialization method for ATM model.
                       Float and string types are acceptable. Float value is interpreted as
                       the value in meter. String value should be the numeric value with
                       unit compatible with length, such as '5km' or '5000m'.

                       Default value is taken from the input MS (ANTENNA table).

        
                   Default Value: 

                temperature: Ambient temperature [K].

                       The value is directly passed to initialization method for ATM model.
                       Float and string types are acceptable. Float value is interpreted as
                       the value in Kelvin. String value should be the numeric value with
                       unit, such as '270K'.

                       Default value is taken from the input MS (ASDM_CALATMOSPHERE table).

        
                   Default Value: 

                pressure: Ambient pressure [mbar].

                       The value is directly passed to initialization method for ATM model.
                       Float and string types are acceptable. Float value is interpreted as
                       the value in mbar. String value should be the numeric value with
                       unit compatible with pressure, such as '1000mbar' or '1000hPa'.

                       Default value is taken from the input MS (ASDM_CALATMOSPHERE table).

        
                   Default Value: 

                humidity: Relative humidity [percent].

                       If the value is explicitly specified, it should range from 0 to 100.

                       Default value (-1) indicates that the value is taken from the input MS
                       (ASDM_CALATMOSPHERE table).

        
                   Default Value: -1

                pwv: Zenith water vapor [mm].

                       The value is directly passed to configuration method for ATM model.
                       Float and string types are acceptable. Float value is interpreted as
                       the value in millimeter. String value should be the numeric value with
                       the unit compatible with length, such as '0.3mm'

                       Default value is taken from the input MS (ASDM_CALWVR table).

        
                   Default Value: 

                dp: Initial pressure step.

                       The value is directly passed to initialization method for ATM model.
                       Float and string types are acceptable. Float value is interpreted as
                       the value in mbar. String value should be the numeric value with
                       unit compatible with pressure, such as '10mbar' or '10hPa'.

                       Default value ('') indicates to use tool default (10mbar).

        
                   Default Value: 

                dpm: Pressure multiplicative factor for steps.

                       The value is directly passed to initialization method for ATM model.
                       Default value (-1) indicates to use tool default (1.2).

        
                   Default Value: -1

                layerboundaries: Altitude of user-defined temperature profile.

                       The value is directly passed to initialization method for ATM model.
                       String, list of strings, and list of float values are acceptable.

                       For list inputs, float values are interpreted as the value in meter
                       while the string values should be the numeric value with the unit
                       compatible with length.

                       For string input, the value should be comma separated list of
                       strings consisting of numeric value and the unit compatible with
                       length.

                       Number of values should be identical to the number for layertemperature.

                       Default value ('') indicates to use tool default.

                       Example: [1000, 2000]
                                ['1km', '2km']
                                '1km,2km'

        
                   Default Value: 

                layertemperature: User-defined temperature profile [K].

                       The value is directly passed to initialization method for ATM model.
                       String, list of strings, and list of float values are acceptable.

                       For list inputs, float values are interpreted as the value in Kelvin
                       while the string values should be the numeric value with unit.

                       For string input, the value should be comma separated list of
                       strings consisting of numeric value and unit.

                       Number of values should be identical to the number for layerboundaries.

                       Example: [250, 240]
                                ['250K', '240K']
                                '250K,240K'

        
                   Default Value: 

        Returns: 

        Example :


        """
        if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=stack_frame_find( )
        #casac = self.__globals__['casac']
        casalog = self.__globals__['casalog']
        casa = self.__globals__['casa']
        #casalog = casac.casac.logsink()
        self.__globals__['__last_task'] = 'sdatmcor'
        self.__globals__['taskname'] = 'sdatmcor'
        ###
        self.__globals__['update_params'](func=self.__globals__['taskname'],printtext=False,ipython_globals=self.__globals__)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
        if type(self.__call__.func_defaults) is NoneType:
            function_signature_defaults={}
        else:
            function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames[1:],self.__call__.func_defaults))
        useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
                        if (key != 'self') :
                           useLocalDefaults = True

        myparams = {}
        if useLocalDefaults :
           for item in function_signature_defaults.iteritems():
               key,val = item
               keyVal = eval(key)
               exec('myparams[key] = keyVal')
               self.parameters[key] = keyVal
               if (keyVal == None):
                   exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
                   keyVal = eval(key)
                   if(type(keyVal) == dict) :
                      if len(keyVal) > 0 :
                         exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')
                      else :
                         exec('myparams[key] = ' + key + ' = {}')

        else :
            print ''

            myparams['infile'] = infile = self.parameters['infile']
            myparams['datacolumn'] = datacolumn = self.parameters['datacolumn']
            myparams['outfile'] = outfile = self.parameters['outfile']
            myparams['overwrite'] = overwrite = self.parameters['overwrite']
            myparams['field'] = field = self.parameters['field']
            myparams['spw'] = spw = self.parameters['spw']
            myparams['scan'] = scan = self.parameters['scan']
            myparams['antenna'] = antenna = self.parameters['antenna']
            myparams['correlation'] = correlation = self.parameters['correlation']
            myparams['timerange'] = timerange = self.parameters['timerange']
            myparams['intent'] = intent = self.parameters['intent']
            myparams['observation'] = observation = self.parameters['observation']
            myparams['feed'] = feed = self.parameters['feed']
            myparams['msselect'] = msselect = self.parameters['msselect']
            myparams['outputspw'] = outputspw = self.parameters['outputspw']
            myparams['gainfactor'] = gainfactor = self.parameters['gainfactor']
            myparams['dtem_dh'] = dtem_dh = self.parameters['dtem_dh']
            myparams['h0'] = h0 = self.parameters['h0']
            myparams['atmtype'] = atmtype = self.parameters['atmtype']
            myparams['atmdetail'] = atmdetail = self.parameters['atmdetail']
            myparams['altitude'] = altitude = self.parameters['altitude']
            myparams['temperature'] = temperature = self.parameters['temperature']
            myparams['pressure'] = pressure = self.parameters['pressure']
            myparams['humidity'] = humidity = self.parameters['humidity']
            myparams['pwv'] = pwv = self.parameters['pwv']
            myparams['dp'] = dp = self.parameters['dp']
            myparams['dpm'] = dpm = self.parameters['dpm']
            myparams['layerboundaries'] = layerboundaries = self.parameters['layerboundaries']
            myparams['layertemperature'] = layertemperature = self.parameters['layertemperature']


        result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['infile'] = infile
        mytmp['datacolumn'] = datacolumn
        mytmp['outfile'] = outfile
        mytmp['overwrite'] = overwrite
        mytmp['field'] = field
        mytmp['spw'] = spw
        mytmp['scan'] = scan
        mytmp['antenna'] = antenna
        mytmp['correlation'] = correlation
        mytmp['timerange'] = timerange
        mytmp['intent'] = intent
        mytmp['observation'] = observation
        mytmp['feed'] = feed
        mytmp['msselect'] = msselect
        mytmp['outputspw'] = outputspw
        mytmp['gainfactor'] = gainfactor
        mytmp['dtem_dh'] = dtem_dh
        mytmp['h0'] = h0
        mytmp['atmtype'] = atmtype
        mytmp['atmdetail'] = atmdetail
        mytmp['altitude'] = altitude
        mytmp['temperature'] = temperature
        mytmp['pressure'] = pressure
        mytmp['humidity'] = humidity
        mytmp['pwv'] = pwv
        mytmp['dp'] = dp
        mytmp['dpm'] = dpm
        mytmp['layerboundaries'] = layerboundaries
        mytmp['layertemperature'] = layertemperature
        pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.casac.utils().torecord(pathname+'sdatmcor.xml')

        casalog.origin('sdatmcor')
        try :
          #if not trec.has_key('sdatmcor') or not casac.casac.utils().verify(mytmp, trec['sdatmcor']) :
            #return False

          casac.casac.utils().verify(mytmp, trec['sdatmcor'], True)
          scriptstr=['']
          saveinputs = self.__globals__['saveinputs']

          # Save .last file for this task execution. MPI servers don't write it (CASR-329).
          from mpi4casa.MPIEnvironment import MPIEnvironment
          do_full_logging = MPIEnvironment.is_mpi_disabled_or_client()
          if type(self.__call__.func_defaults) is NoneType:
              saveinputs=''
          else:
              saveinputs('sdatmcor', 'sdatmcor.last', myparams, self.__globals__,scriptstr=scriptstr, do_save_inputs=do_full_logging)

          tname = 'sdatmcor'
          spaces = ' '*(18-len(tname))
          casalog.post('\n##########################################'+
                       '\n##### Begin Task: ' + tname + spaces + ' #####')
          # Don't do telemetry from MPI servers (CASR-329)
          if do_full_logging and casa['state']['telemetry-enabled']:
              #casalog.poststat('Begin Task: ' + tname)
              task_starttime = str(datetime.datetime.now())
          if type(self.__call__.func_defaults) is NoneType:
              casalog.post(scriptstr[0]+'\n', 'INFO')
          else:
              casalog.post(scriptstr[1][1:]+'\n', 'INFO')

          # Effective call to the task as defined in gcwrap/python/scripts/task_*
          result = sdatmcor(infile, datacolumn, outfile, overwrite, field, spw, scan, antenna, correlation, timerange, intent, observation, feed, msselect, outputspw, gainfactor, dtem_dh, h0, atmtype, atmdetail, altitude, temperature, pressure, humidity, pwv, dp, dpm, layerboundaries, layertemperature)

          if do_full_logging and casa['state']['telemetry-enabled']:
              task_endtime = str(datetime.datetime.now())
              casalog.poststat( 'Task ' + tname + ' complete. Start time: ' + task_starttime + ' End time: ' + task_endtime )
          casalog.post('##### End Task: ' + tname + '  ' + spaces + ' #####'+
                       '\n##########################################')

        except Exception, instance:
          from mpi4casa.MPIEnvironment import MPIEnvironment
          if (self.__globals__.has_key('__rethrow_casa_exceptions') and self.__globals__['__rethrow_casa_exceptions']) or\
             (MPIEnvironment.is_mpi_enabled and not MPIEnvironment.is_mpi_client):
             raise
          else:
             #print '**** Error **** ',instance
             tname = 'sdatmcor'
             casalog.post('Task {} raised an exception of class {} with the following message: {}'.
                          format(tname, type(instance).__name__, instance), 'ERROR')
             pass
        casalog.origin('')

        return result
#
#
#
#    def paramgui(self, useGlobals=True, ipython_globals=None):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#        if not hasattr(self, "__globals__") or self.__globals__ == None :
#           self.__globals__=stack_frame_find( )
#
#        if useGlobals:
#            if ipython_globals == None:
#                myf=self.__globals__
#            else:
#                myf=ipython_globals
#
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('sdatmcor', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None, ipython_globals=None, paramvalue=None, subparam=None):
        if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=stack_frame_find( )
        if ipython_globals == None:
            myf=self.__globals__
        else:
            myf=ipython_globals

        a = odict()
        a['infile']  = ''
        a['datacolumn']  = 'data'
        a['outfile']  = ''
        a['overwrite']  = False
        a['field']  = ''
        a['spw']  = ''
        a['scan']  = ''
        a['antenna']  = ''
        a['correlation']  = ''
        a['timerange']  = ''
        a['intent']  = ''
        a['observation']  = ''
        a['feed']  = ''
        a['msselect']  = ''
        a['outputspw']  = ''
        a['gainfactor']  = 1.0
        a['dtem_dh']  = ''
        a['h0']  = ''
        a['atmtype']  = 2
        a['atmdetail']  = False

        a['atmdetail'] = {
                    0:{'value':False}, 
                    1:odict([{'value':True}, {'altitude':''}, {'temperature':''}, {'pressure':''}, {'humidity':-1}, {'pwv':''}, {'dp':''}, {'dpm':-1}, {'layerboundaries':''}, {'layertemperature':''}])}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
            if(paramvalue==None and subparam==None):
               if(a.has_key(param)):
                  return a[param]
               else:
                  return self.itsdefault(param)
            else:
               retval=a[param]
               if(type(a[param])==dict):
                  for k in range(len(a[param])):
                     valornotval='value'
                     if(a[param][k].has_key('notvalue')):
                        valornotval='notvalue'
                     if((a[param][k][valornotval])==paramvalue):
                        retval=a[param][k].copy()
                        retval.pop(valornotval)
                        if(subparam != None):
                           if(retval.has_key(subparam)):
                              retval=retval[subparam]
                           else:
                              retval=self.itsdefault(subparam)
                     else:
                        retval=self.itsdefault(subparam)
               return retval


#
#
    def check_params(self, param=None, value=None, ipython_globals=None):
      if ipython_globals == None:
          myf=self.__globals__
      else:
          myf=ipython_globals
#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value
#
#
    def description(self, key='sdatmcor', subkey=None):
        desc={'sdatmcor': 'Offline correction of residual atmospheric features',
               'infile': 'name of input MS.',
               'datacolumn': 'name of data column to be used ["data", "float_data", or "corrected"]',
               'outfile': 'name of output MS.',
               'overwrite': 'allow to overwrite the output file if already exists.',
               'field': 'field(s) to select',
               'spw': 'spws to select',
               'scan': 'Scan number range',
               'antenna': 'Select data based on antenna',
               'correlation': 'Correlation (polarization) types or expression',
               'timerange': 'Range of time to select from data',
               'intent': 'Scan Intent(s)',
               'observation': 'Observation ID range',
               'feed': 'feed selection',
               'msselect': 'Complicated data selection using TaQL',
               'outputspw': 'select spws to output, same syntax of spw.("" = all)',
               'gainfactor': 'Gain factor to multiply correction term',
               'dtem_dh': 'temperature gradient [K/km], e.g. -5.6. ("" = Tool default) ',
               'h0': 'scale height for water [km], e.g. 2.0. ("" = Tool default)',
               'atmtype': 'Specify atmtype as integer. Options are 1: tropical, 2: mid latitude summer, 3: mid latitude winter, 4: subarctic summer, 5: subarctic winter',
               'atmdetail': 'Expose sub-parameters if True.',
               'altitude': 'Site altitude [m]. ("" = value from MS.)',
               'temperature': 'Ambient temperature [K]. ("" = value from MS.)',
               'pressure': 'Ambient pressure [mbar]. ("" = value from MS.)',
               'humidity': 'Relative humidity [percent]. -1 or the value (0.0 - 100.0) (-1 = Tool default)',
               'pwv': 'Zenith water vapor [mm]. ("" = Tool default)',
               'dp': 'Initial pressure step [mbar].("" = Tool default)',
               'dpm': 'Pressure multiplicative factor for steps. (-1 = Tool default)',
               'layerboundaries': 'Altitude of user-defined temperature profile [m]. ("" = Tool default)',
               'layertemperature': 'User-defined temperature profile [K]. ("" = Tool default)',

              }

#
# Set subfields defaults if needed
#

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['infile']  = ''
        a['datacolumn']  = 'data'
        a['outfile']  = ''
        a['overwrite']  = False
        a['field']  = ''
        a['spw']  = ''
        a['scan']  = ''
        a['antenna']  = ''
        a['correlation']  = ''
        a['timerange']  = ''
        a['intent']  = ''
        a['observation']  = ''
        a['feed']  = ''
        a['msselect']  = ''
        a['outputspw']  = ''
        a['gainfactor']  = 1.0
        a['dtem_dh']  = ''
        a['h0']  = ''
        a['atmtype']  = 2
        a['atmdetail']  = False
        a['altitude']  = ''
        a['temperature']  = ''
        a['pressure']  = ''
        a['humidity']  = -1
        a['pwv']  = ''
        a['dp']  = ''
        a['dpm']  = -1
        a['layerboundaries']  = ''
        a['layertemperature']  = ''

        #a = sys._getframe(len(inspect.stack())-1).f_globals

        if self.parameters['atmdetail']  == True:
            a['altitude'] = ''
            a['temperature'] = ''
            a['pressure'] = ''
            a['humidity'] = -1
            a['pwv'] = ''
            a['dp'] = ''
            a['dpm'] = -1
            a['layerboundaries'] = ''
            a['layertemperature'] = ''

        if a.has_key(paramname) :
              return a[paramname]
sdatmcor_cli = sdatmcor_cli_()
