#
# This file was generated using xslt from its XML file
#
# Copyright 2009, Associated Universities Inc., Washington DC
#
import sys
import os
from  casac import *
import string
from taskinit import casalog
from taskinit import xmlpath
#from taskmanager import tm
import task_sdtimeaverage
def sdtimeaverage(infile='', datacolumn='float_data', field='', spw='', timerange='', scan='', antenna='', timebin='all', timespan='scan', outfile=''):

        """Average SD data, perform time averaging  
-----------------
Keyword arguments
-----------------
infile -- name of input SD dataset
datacolumn -- name of data column to be used
        options: 'data', 'float_data', or 'corrected_data'
        default: 'float_data'
        In case the column 'float_data' does not exists on the specified MS,
        sdtimeaverage alternatively attempt to use 'data' column.  
            
field -- select data by field IDs and names
        default: '' (use all fields)
        example: field='3C2*' (all names starting with 3C2)
                 field='0,4,5~7' (field IDs 0,4,5,6,7)
                 field='0,3C273' (field ID 0 or field named 3C273)
        this selection is in addition to the other selections to data
spw -- select data by IF IDs (spectral windows)
        default: '' (use all IFs)
        example: spw='0~2,4'; spectral windows 0,1,2,4 (all channels)
                 spw='<2';  spectral windows less than 2 (i.e. 0,1)
        this selection is in addition to the other selections to data
timerange -- select data by time range
        default: '' (use all)
        example: timerange = 'YYYY/MM/DD/hh:mm:ss~YYYY/MM/DD/hh:mm:ss'
                 Note: YYYY/MM/DD can be dropped as needed:
                 timerange='09:14:00~09:54:00' # this time range
                 timerange='09:44:00' # data within one integration of time
                 timerange='>10:24:00' # data after this time
                 timerange='09:44:00+00:13:00' #data 13 minutes after time
        this selection is in addition to the other selections to data
scan -- select data by scan numbers
        default: '' (use all scans)
        example: scan='21~23' (scan IDs 21,22,23)
        this selection is in addition to the other selections to data
antenna -- select data by antenna name or ID
        default: '' (use all antennas)
        example: 'PM03'
timebin -- bin width for time averaging
           default: 'all' 
           example: timebin='100s' (time averaging performed over 100 second bins)
                    timebin=''  (use all)
timespan -- Let the timebin span across scan, state or both.
            State is equivalent to sub-scans. One scan may have several
            state ids. For ALMA MSs, the sub-scans are limited to about
            30s duration each. In these cases, the task will automatically
            add state to the timespan parameter. To see the number of states
            in an MS, use the msmd tool. See help msmd.

        default: 'scan' (separate time bins by both of the above)
        options: 'scan', 'state', 'state,scan', ''
               
        examples:
             timespan = 'scan'; can be useful when the scan number
             goes up with each integration as in many WSRT MSs.
             timespan = ['scan', 'state']: disregard scan and state
             numbers when time averaging.
             timespan = 'state,scan'; same as above
             timespan = '': averages for each combination of scan and state
outfile -- name of output file


        """

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['infile'] = infile
        mytmp['datacolumn'] = datacolumn
        mytmp['field'] = field
        mytmp['spw'] = spw
        mytmp['timerange'] = timerange
        mytmp['scan'] = scan
        mytmp['antenna'] = antenna
        mytmp['timebin'] = timebin
        mytmp['timespan'] = timespan
        mytmp['outfile'] = outfile
        pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.utils().torecord(pathname+'sdtimeaverage.xml')

        casalog.origin('sdtimeaverage')
        if trec.has_key('sdtimeaverage') and casac.utils().verify(mytmp, trec['sdtimeaverage']) :
            result = task_sdtimeaverage.sdtimeaverage(infile, datacolumn, field, spw, timerange, scan, antenna, timebin, timespan, outfile)

        else :
          result = False
        return result
