#
# This file was generated using xslt from its XML file
#
# Copyright 2014, Associated Universities Inc., Washington DC
#
import sys
import os
import datetime
#from casac import *
import casac
import string
import time
import inspect
import numpy
from casa_stack_manip import stack_frame_find
from odict import odict
from types import *
from task_simanalyze import simanalyze
class simanalyze_cli_:
    __name__ = "simanalyze"
    rkey = None
    i_am_a_casapy_task = None
    # The existence of the i_am_a_casapy_task attribute allows help()
    # (and other) to treat casapy tasks as a special case.

    def __init__(self) :
       self.__bases__ = (simanalyze_cli_,)
       self.__doc__ = self.__call__.__doc__

       self.parameters={'project':None, 'image':None, 'imagename':None, 'skymodel':None, 'vis':None, 'modelimage':None, 'imsize':None, 'imdirection':None, 'cell':None, 'interactive':None, 'niter':None, 'threshold':None, 'weighting':None, 'mask':None, 'outertaper':None, 'pbcor':None, 'stokes':None, 'featherimage':None, 'analyze':None, 'showuv':None, 'showpsf':None, 'showmodel':None, 'showconvolved':None, 'showclean':None, 'showresidual':None, 'showdifference':None, 'showfidelity':None, 'graphics':None, 'verbose':None, 'overwrite':None, 'dryrun':None, 'logfile':None, }


    def result(self, key=None):
            #### and add any that have completed...
            return None


    def __call__(self, project=None, image=None, imagename=None, skymodel=None, vis=None, modelimage=None, imsize=None, imdirection=None, cell=None, interactive=None, niter=None, threshold=None, weighting=None, mask=None, outertaper=None, pbcor=None, stokes=None, featherimage=None, analyze=None, showuv=None, showpsf=None, showmodel=None, showconvolved=None, showclean=None, showresidual=None, showdifference=None, showfidelity=None, graphics=None, verbose=None, overwrite=None, dryrun=None, logfile=None, ):

        """image and analyze measurement sets created with simobserve

        Detailed Description:

    This task is for imaging and analyzing MeasurementSets simulated with simobserve or simalma.
    It consists of two main steps, controlled by the image and analyze parameters.
    -------------------------------
    Output produced: (not all will always exist, depending on input parameters)
    To support different runs with different arrays, the names have the
    configuration name from antennalist appended.
    -------------------------------
    * tclean outputs:
    [project].[cfg].image = synthesized image
    [project].[cfg].residual = residual image after cleaning
    [project].[cfg].pb = primary beam
    [project].[cfg].image.pbcor = synthesized image corrected for primary beam attenuation
    [project].[cfg].psf = synthesized (dirty) beam calculated from weighted uv distribution
    [project].[cfg].mask = clean mask
    [project].[cfg].model = sky brightness model
    [project].[cfg].sumwt = single pixel image containing sum-of-weights
    [project].[cfg].weight = Fourier transform of gridder weights, or un-normalized sum of PB-square (for all pointings)
    [project].[cfg].tclean.last = parameter file of what parameters were used in the tclean task; also generated by simutil even when dryrun=True

    * simulator outputs:
    [project].[cfg].skymodel.flat.regrid.conv = input sky regridded to match the output image, and convolved with the output clean beam
    [project].[cfg].fidelity = fidelity image
    [project].[cfg].image.png = diagnostic figure of clean image and residual
    [project].[cfg].analysis.png = diagnostic figure of difference and fidelity
    [project].[cfg].diff = difference image between flattened convolved model and flattened output
    [project].[cfg].image.flat = 2D integrated intensity image, not corrected for primary beam; see simutil.modifymodel
    [project].[cfg].simanalyze.last = saved input parameters for simanalyze task, available in CASAshell
    -------------------------------

    * "project" needs to be the directory of results generated by running 
      simobserve or simalma. In particular $project/$project.skymodel 
      will be required in order to compare output and input images.

    * NOTE: simanalyze was designed to be used after one or more runs of
      simobserve, and as such it assumes it will be able to find a 
      sky model image called $project/$project.skymodel, .newmodel, or 
      .compskymodel in the $project/ subdirectory.  If the simulated 
      MS has been created by means other than simply calling simobserve, 
      the user may have to copy their sky model image into the $project
      subdirectory and call it "$project.skymodel".

    * interactive clean or use of more parameters than the subset 
      visible here are available by simply running the tclean task directly, 
      then using simanalyze in the mode image=False (see below).

    * Sometimes it is preferable to grid the single dish MS using the 
      sdimaging task for more control.  In that case one can input 
      the resulting single dish imaging under "featherimage", only 
      put interferometric MSs in "vis", and simanalyze  will clean the 
      interferometric and feather with your "featherimage".

    * uses Cotton-Schwab clean for single fields and Mosaic gridding
      for multiple fields (with Clark PSF calculation in minor cycles).
  
        Arguments :
                project: 
        root prefix for input and output file names.  
        This must be the directory of results generated by running 
        simobserve or simalma. In particular $project/$project.skymodel 
        will be required in order to compare output and input images.
      
                   Default Value: sim

                image: Controls whether tclean is called to image the MeasurementSet data. If true, input one or more simulated MSs using the vis parameter. These can include a total power MS. This task will grid any total power MS, invert and deconvolve any interferometric MS(s) (using the simutil method imtclean), and feather the results. If this parameter is set to False (e.g., if the user has created a synthesized image themselves or simanalyze has previously been run with image=True) the user should provide that image as input to the imagename parameter. This task will then attempt to find an appropriate skymodel image (such as the optionally rescaled *.skymodel produced by simobserve or simalma and used to create the MS).
                   Default Value: True

                imagename: Name of image to image/analyze, expected to be of the same form as those generated by simobserve. Defaults to the first file found with the name $project/*.image
                   Default Value: default

                skymodel: Name of a specific .skymodel image created by simobserve or simalma and used by one of those tasks to create a MS. If unspecified, will try to find one similar to your specified output image name.
                   Default Value: 

                vis: Name of the Measurement Set(s) to image, specified as a string or string containing a comma separating the names. If set to "default", will attempt to find and image all MeasurementSets (interferometric and single dish) in the project directory. Note that if you created MeasurementSets using simobserve, the names will include the antenna configuration. Example of a single MS: vis="mysim.alma.out03.ms". Example of multiple MSs: vis="mysim.alma.out03.ms,mysim.aca.tp.ms". Example of using the $project syntax: vis="$project.noisy.ms,$project.noisy.sd.ms".
                   Default Value: default

                modelimage: Sometimes it is preferable to use a low resolution (single dish or synthesis) image as a starting model during clean deconvolution of a higher resolution interferometric MS.  That is accomplished by specifying the low-resolution image as input to this parameter, and the MS to be deconvolved as input to the vis parameter. This parameter is passed to the startmodel parameter of tclean via the simutil method imtclean. Note that this is separate from the functionality controlled by the featherimage parameter and that it is not necessarily the original skymodel that was used in simobserve or simalma. Also note that the modelimage will not be used if the MS to be imaged is total power.
                   Default Value: 

                imsize: A list of integers corresponding to the number of pixels in (x,y) dimensions of output image. If 0, will attempt to match model image.
                   Default Value: 00

                imdirection: A string corresponding to a direction to adopt as phase center, including epoch, right ascension, and declination. If unset, will adopt center on the model.
                   Default Value: 

                cell: Specify the cell size with units, e.g., "10arcsec". If left unset (an empty string), the model cell size will be used. This is the default setting.
                   Default Value: 

                interactive: Controls how the simutil method imtclean will call the tclean task. If this parameter is set to True, make sure to set the parameter niter to a value >0.
                   Default Value: False

                niter: Controls the value of the niter parameter in tclean call, and thus the maximum number of iterations per minor cycle. Set to 0 to produce a dirty image. Can also be modified through the viewer GUI via the interactive parameter.
                   Default Value: 0

                threshold: Set the quantity corresponding to the target flux level at which to stop cleaning. This value is passed to tclean via the simutil method imtclean.
                   Default Value: 0.1mJy

                weighting: Set the weighting scheme to apply to visibilities during image reconstruction. If set to briggs, will use the tclean default robust parameter (0.5)
                   Default Value: natural
                   Allowed Values:
                                natural
                                uniform
                                briggs

                mask: Accepts a list of cleanbox(es), mask image file name(s), region(s), and/or a primary beam coverage level. Input to this parameter will specify areas to be searched for clean components. tclean tends to perform better and is less likely to diverge if the component placement is limited by a mask to where real emission is expected. See the tclean task documentation for more information about masking. Example of a pixel range mask: mask=[110,110,150,145]
                   Default Value: 

                outertaper: Accepts a list of strings in the form of a quantity that sets an other threshold on baselines in the uv-plane. Usually used to achieve a lower effective angular resolution and recover more extended emission in reconstructed image. If left unset via empty list (the default) no outer taper will be applied.
                   Default Value: 

                pbcor: Controls whether primary beam correction is applied in the call to task tclean.
                   Default Value: True

                stokes: Stokes parameters to include in the call to tclean via the simutil method imtclean. Note that forming Stokes Q and U images requires the presence of cross-hand polarizations (e.g., RL and LR for circularly polarized systems such as the VLA) in the input data. Stokes V requires both parallel hands (RR and LL) for circularly-polarized systems or the cross-hands (XY and YX) for linearly polarized systems such as ALMA and ATCA.
                   Default Value: I
                   Allowed Values:
                                I
                                IV
                                QU
                                IQUV
                                RR
                                LL
                                RRLL
                                XX
                                YY
                                XXYY

                featherimage: String corresponding to the name of an image (e.g., total power data) to feather with the interferometric synthesis image. Sometimes it is preferable to grid the single dish MS using the sdimaging task for more control. In that case, the user can input the resulting single dish imaging under featherimage, only pass interferometric data as input to the vis parameter, and this task will clean the interferometric and feather with the featherimage.
                   Default Value: 

                analyze: Used to create an image of the difference between the input skymodel and the simulated output image (whether that output image is being generated in the same call to simanalyze, with image=True, or has already been generated, and simanalyze is being called with image=False). If True, only the first 6 selected subparameter outputs will be displayed.
                   Default Value: False

                showuv: Displays a plot of the simulated uv coverage
                   Default Value: True

                showpsf: Displays synthesized (dirty) beam. Ignored in single dish simulation.
                   Default Value: True

                showmodel: Displays the sky model at original resolution of input image.
                   Default Value: True

                showconvolved: Displays the sky model convolved with output clean beam.
                   Default Value: False

                showclean: Displays the synthesized image produced by the call to task tclean.
                   Default Value: True

                showresidual: Displays the residual image produced by the call to task tclean. Ignored in single dish simulations.
                   Default Value: False

                showdifference: Displays a difference image between cleaned image output by the tclean call, and input model sky image convolved with synthesized beam determined by output of tclean call.
                   Default Value: True

                showfidelity: Display a fidelity image. Note that the RMS is calculated in the lower quarter of the image. This is likely not the best choice, so you are encouraged to measure RMS yourself in an off-source region. Fidelity = abs(input) / max[ abs(input-output), 0.7*rms(output) ]
                   Default Value: True

                graphics: Controls where graphics are displayed. Options are screen, file, both, or none.
                   Default Value: both
                   Allowed Values:
                                screen
                                file
                                both
                                none
                                

                verbose: Controls task activity is reported in the log.
                   Default Value: False

                overwrite: Controls whether the task will overwrite existing files starting with $project name.
                   Default Value: True

                logfile: Allows for a user-defined log file naming convention if the verbose parameter is set to True.
                   Default Value: 

        Returns: void

        Example :

	For more information, see the task pages of simobserve in CASA Docs:
	
	https://casa.nrao.edu/casadocs/

	Please see http://casaguides.nrao.edu, and contact the CASA helpdesk 
	with questions.
  
        """
        if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=stack_frame_find( )
        #casac = self.__globals__['casac']
        casalog = self.__globals__['casalog']
        casa = self.__globals__['casa']
        #casalog = casac.casac.logsink()
        self.__globals__['__last_task'] = 'simanalyze'
        self.__globals__['taskname'] = 'simanalyze'
        ###
        self.__globals__['update_params'](func=self.__globals__['taskname'],printtext=False,ipython_globals=self.__globals__)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
        if type(self.__call__.func_defaults) is NoneType:
            function_signature_defaults={}
        else:
            function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames[1:],self.__call__.func_defaults))
        useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
                        if (key != 'self') :
                           useLocalDefaults = True

        myparams = {}
        if useLocalDefaults :
           for item in function_signature_defaults.iteritems():
               key,val = item
               keyVal = eval(key)
               exec('myparams[key] = keyVal')
               self.parameters[key] = keyVal
               if (keyVal == None):
                   exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
                   keyVal = eval(key)
                   if(type(keyVal) == dict) :
                      if len(keyVal) > 0 :
                         exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')
                      else :
                         exec('myparams[key] = ' + key + ' = {}')

        else :
            print ''

            myparams['project'] = project = self.parameters['project']
            myparams['image'] = image = self.parameters['image']
            myparams['imagename'] = imagename = self.parameters['imagename']
            myparams['skymodel'] = skymodel = self.parameters['skymodel']
            myparams['vis'] = vis = self.parameters['vis']
            myparams['modelimage'] = modelimage = self.parameters['modelimage']
            myparams['imsize'] = imsize = self.parameters['imsize']
            myparams['imdirection'] = imdirection = self.parameters['imdirection']
            myparams['cell'] = cell = self.parameters['cell']
            myparams['interactive'] = interactive = self.parameters['interactive']
            myparams['niter'] = niter = self.parameters['niter']
            myparams['threshold'] = threshold = self.parameters['threshold']
            myparams['weighting'] = weighting = self.parameters['weighting']
            myparams['mask'] = mask = self.parameters['mask']
            myparams['outertaper'] = outertaper = self.parameters['outertaper']
            myparams['pbcor'] = pbcor = self.parameters['pbcor']
            myparams['stokes'] = stokes = self.parameters['stokes']
            myparams['featherimage'] = featherimage = self.parameters['featherimage']
            myparams['analyze'] = analyze = self.parameters['analyze']
            myparams['showuv'] = showuv = self.parameters['showuv']
            myparams['showpsf'] = showpsf = self.parameters['showpsf']
            myparams['showmodel'] = showmodel = self.parameters['showmodel']
            myparams['showconvolved'] = showconvolved = self.parameters['showconvolved']
            myparams['showclean'] = showclean = self.parameters['showclean']
            myparams['showresidual'] = showresidual = self.parameters['showresidual']
            myparams['showdifference'] = showdifference = self.parameters['showdifference']
            myparams['showfidelity'] = showfidelity = self.parameters['showfidelity']
            myparams['graphics'] = graphics = self.parameters['graphics']
            myparams['verbose'] = verbose = self.parameters['verbose']
            myparams['overwrite'] = overwrite = self.parameters['overwrite']
            myparams['dryrun'] = dryrun = self.parameters['dryrun']
            myparams['logfile'] = logfile = self.parameters['logfile']

        if type(imsize)==int: imsize=[imsize]
        if type(outertaper)==str: outertaper=[outertaper]

        result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['project'] = project
        mytmp['image'] = image
        mytmp['imagename'] = imagename
        mytmp['skymodel'] = skymodel
        mytmp['vis'] = vis
        mytmp['modelimage'] = modelimage
        mytmp['imsize'] = imsize
        mytmp['imdirection'] = imdirection
        mytmp['cell'] = cell
        mytmp['interactive'] = interactive
        mytmp['niter'] = niter
        mytmp['threshold'] = threshold
        mytmp['weighting'] = weighting
        mytmp['mask'] = mask
        mytmp['outertaper'] = outertaper
        mytmp['pbcor'] = pbcor
        mytmp['stokes'] = stokes
        mytmp['featherimage'] = featherimage
        mytmp['analyze'] = analyze
        mytmp['showuv'] = showuv
        mytmp['showpsf'] = showpsf
        mytmp['showmodel'] = showmodel
        mytmp['showconvolved'] = showconvolved
        mytmp['showclean'] = showclean
        mytmp['showresidual'] = showresidual
        mytmp['showdifference'] = showdifference
        mytmp['showfidelity'] = showfidelity
        mytmp['graphics'] = graphics
        mytmp['verbose'] = verbose
        mytmp['overwrite'] = overwrite
        mytmp['dryrun'] = dryrun
        mytmp['logfile'] = logfile
        pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.casac.utils().torecord(pathname+'simanalyze.xml')

        casalog.origin('simanalyze')
        try :
          #if not trec.has_key('simanalyze') or not casac.casac.utils().verify(mytmp, trec['simanalyze']) :
            #return False

          casac.casac.utils().verify(mytmp, trec['simanalyze'], True)
          scriptstr=['']
          saveinputs = self.__globals__['saveinputs']

          # Save .last file for this task execution. MPI servers don't write it (CASR-329).
          from mpi4casa.MPIEnvironment import MPIEnvironment
          do_full_logging = MPIEnvironment.is_mpi_disabled_or_client()
          if type(self.__call__.func_defaults) is NoneType:
              saveinputs=''
          else:
              saveinputs('simanalyze', 'simanalyze.last', myparams, self.__globals__,scriptstr=scriptstr, do_save_inputs=do_full_logging)

          tname = 'simanalyze'
          spaces = ' '*(18-len(tname))
          casalog.post('\n##########################################'+
                       '\n##### Begin Task: ' + tname + spaces + ' #####')
          # Don't do telemetry from MPI servers (CASR-329)
          if do_full_logging and casa['state']['telemetry-enabled']:
              #casalog.poststat('Begin Task: ' + tname)
              task_starttime = str(datetime.datetime.now())
          if type(self.__call__.func_defaults) is NoneType:
              casalog.post(scriptstr[0]+'\n', 'INFO')
          else:
              casalog.post(scriptstr[1][1:]+'\n', 'INFO')

          # Effective call to the task as defined in gcwrap/python/scripts/task_*
          result = simanalyze(project, image, imagename, skymodel, vis, modelimage, imsize, imdirection, cell, interactive, niter, threshold, weighting, mask, outertaper, pbcor, stokes, featherimage, analyze, showuv, showpsf, showmodel, showconvolved, showclean, showresidual, showdifference, showfidelity, graphics, verbose, overwrite, dryrun, logfile)

          if do_full_logging and casa['state']['telemetry-enabled']:
              task_endtime = str(datetime.datetime.now())
              casalog.poststat( 'Task ' + tname + ' complete. Start time: ' + task_starttime + ' End time: ' + task_endtime )
          casalog.post('##### End Task: ' + tname + '  ' + spaces + ' #####'+
                       '\n##########################################')

        except Exception, instance:
          from mpi4casa.MPIEnvironment import MPIEnvironment
          if (self.__globals__.has_key('__rethrow_casa_exceptions') and self.__globals__['__rethrow_casa_exceptions']) or\
             (MPIEnvironment.is_mpi_enabled and not MPIEnvironment.is_mpi_client):
             raise
          else:
             #print '**** Error **** ',instance
             tname = 'simanalyze'
             casalog.post('Task {} raised an exception of class {} with the following message: {}'.
                          format(tname, type(instance).__name__, instance), 'ERROR')
             pass
        casalog.origin('')

        return result
#
#
#
#    def paramgui(self, useGlobals=True, ipython_globals=None):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#        if not hasattr(self, "__globals__") or self.__globals__ == None :
#           self.__globals__=stack_frame_find( )
#
#        if useGlobals:
#            if ipython_globals == None:
#                myf=self.__globals__
#            else:
#                myf=ipython_globals
#
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('simanalyze', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None, ipython_globals=None, paramvalue=None, subparam=None):
        if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=stack_frame_find( )
        if ipython_globals == None:
            myf=self.__globals__
        else:
            myf=ipython_globals

        a = odict()
        a['project']  = 'sim'
        a['image']  = True
        a['analyze']  = False
        a['graphics']  = 'both'
        a['verbose']  = False
        a['overwrite']  = True
        a['dryrun']  = False
        a['logfile']  = ''

        a['image'] = {
                    0:odict([{'value':True}, {'vis':'default'}, {'modelimage':''}, {'imsize':0}, {'imdirection':''}, {'cell':''}, {'interactive':False}, {'niter':0}, {'threshold':'0.1mJy'}, {'weighting':'natural'}, {'mask':[]}, {'outertaper':[]}, {'pbcor':True}, {'stokes':'I'}, {'featherimage':''}]), 
                    1:odict([{'value':False}, {'imagename':'default'}, {'skymodel':''}])}
        a['analyze'] = {
                    0:{'value':False}, 
                    1:odict([{'value':True}, {'showuv':True}, {'showpsf':True}, {'showmodel':True}, {'showconvolved':False}, {'showclean':True}, {'showresidual':False}, {'showdifference':True}, {'showfidelity':True}])}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
            if(paramvalue==None and subparam==None):
               if(a.has_key(param)):
                  return a[param]
               else:
                  return self.itsdefault(param)
            else:
               retval=a[param]
               if(type(a[param])==dict):
                  for k in range(len(a[param])):
                     valornotval='value'
                     if(a[param][k].has_key('notvalue')):
                        valornotval='notvalue'
                     if((a[param][k][valornotval])==paramvalue):
                        retval=a[param][k].copy()
                        retval.pop(valornotval)
                        if(subparam != None):
                           if(retval.has_key(subparam)):
                              retval=retval[subparam]
                           else:
                              retval=self.itsdefault(subparam)
                     else:
                        retval=self.itsdefault(subparam)
               return retval


#
#
    def check_params(self, param=None, value=None, ipython_globals=None):
      if ipython_globals == None:
          myf=self.__globals__
      else:
          myf=ipython_globals
#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value
#
#
    def description(self, key='simanalyze', subkey=None):
        desc={'simanalyze': 'image and analyze measurement sets created with simobserve',
               'project': 'root prefix for output file names',
               'image': '(re)image $project.*.ms to $project.image',
               'imagename': 'simulation output image to analyze',
               'skymodel': 'skymodel image to analyze',
               'vis': 'Measurement Set(s) to image',
               'modelimage': 'image to use as clean prior',
               'imsize': 'output image size in pixel units',
               'imdirection': 'set output image direction',
               'cell': 'cell size with units',
               'interactive': 'call tclean in interactive mode',
               'niter': 'maximum number of iterations',
               'threshold': 'target flux level and units',
               'weighting': 'control image weighting method',
               'mask': 'Cleanbox(es), mask image(s), region(s), or a level',
               'outertaper': 'uv-taper on outer baselines in uv-plane',
               'pbcor': 'correct synthesis images for primary beam response?',
               'stokes': 'Stokes parameterss to image',
               'featherimage': 'image to feather with new image',
               'analyze': 'create analytical images',
               'showuv': 'display uv coverage',
               'showpsf': 'display synthesized beam',
               'showmodel': 'display sky model at original resolution',
               'showconvolved': 'display sky model convolved with output clean beam',
               'showclean': 'display the synthesized image',
               'showresidual': 'display the clean residual image',
               'showdifference': 'display difference between cleaned output and convolved model input',
               'showfidelity': 'display fidelity image',
               'graphics': 'where to display graphics at each stage',
               'verbose': 'report task activity',
               'overwrite': 'overwrite files starting with $project',
               'dryrun': 'only print information',
               'logfile': 'user-defined log file',

              }

#
# Set subfields defaults if needed
#

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['project']  = 'sim'
        a['image']  = True
        a['imagename']  = 'default'
        a['skymodel']  = ''
        a['vis']  = 'default'
        a['modelimage']  = ''
        a['imsize']  = [0, 0]
        a['imdirection']  = ''
        a['cell']  = ''
        a['interactive']  = False
        a['niter']  = 0
        a['threshold']  = '0.1mJy'
        a['weighting']  = 'natural'
        a['mask']  = []
        a['outertaper']  = ['']
        a['pbcor']  = True
        a['stokes']  = 'I'
        a['featherimage']  = ''
        a['analyze']  = False
        a['showuv']  = True
        a['showpsf']  = True
        a['showmodel']  = True
        a['showconvolved']  = False
        a['showclean']  = True
        a['showresidual']  = False
        a['showdifference']  = True
        a['showfidelity']  = True
        a['graphics']  = 'both'
        a['verbose']  = False
        a['overwrite']  = True
        a['dryrun']  = False
        a['logfile']  = ''

        #a = sys._getframe(len(inspect.stack())-1).f_globals

        if self.parameters['image']  == True:
            a['vis'] = 'default'
            a['modelimage'] = ''
            a['imsize'] = 0
            a['imdirection'] = ''
            a['cell'] = ''
            a['interactive'] = False
            a['niter'] = 0
            a['threshold'] = '0.1mJy'
            a['weighting'] = 'natural'
            a['mask'] = []
            a['outertaper'] = []
            a['pbcor'] = True
            a['stokes'] = 'I'
            a['featherimage'] = ''

        if self.parameters['image']  == False:
            a['imagename'] = 'default'
            a['skymodel'] = ''

        if self.parameters['analyze']  == True:
            a['showuv'] = True
            a['showpsf'] = True
            a['showmodel'] = True
            a['showconvolved'] = False
            a['showclean'] = True
            a['showresidual'] = False
            a['showdifference'] = True
            a['showfidelity'] = True

        if a.has_key(paramname) :
              return a[paramname]
simanalyze_cli = simanalyze_cli_()
